#! /bin/sh
# common.sh -- version 1.3 -- 2019/04/16 16:26:26
# (c) INRIA
# Author: Wendelin Serwe
# fonctions auxiliaires utiles pour plusieurs scripts

# -----------------------------------------------------------------------------
# verification de la presence d'un parametre supplementaire

CHECK_PARAMETER () {
# $1 : option courante
# $2 : nombre de parametres restantes

	if [ $2 -lt 1 ] ; then
		echo "$COMMAND: missing parameter for option \`\`$1''"
		exit 1
	fi
}

# -----------------------------------------------------------------------------
# affichage de messages de progression

# affichage si l'option "-verbose" est presente
ECHO () {
	if [ "$SILENT" = -verbose ] ; then
		if [ "$1" = "" ] ; then
			echo ""
		else
			printf "$COMMAND: %s\n" "$1"
		fi
	fi
}

# affichage si l'option "-silent" n'est pas presente
NO_ECHO () {
	if [ "$SILENT" != -silent ] ; then
		if [ "$1" = "" ] ; then
			echo ""
		else
			printf "$COMMAND: %s\n" "$1"
		fi
	fi
}

# -----------------------------------------------------------------------------
# affichage de messages d'erreur

ERROR () {
	printf "$COMMAND: %s\n" "$1"
	exit 1
}

# -----------------------------------------------------------------------------
