/******************************************************************************
 *                           O P E N / C A E S A R
 *-----------------------------------------------------------------------------
 *   INRIA - Unite de Recherche Rhone-Alpes
 *   655, avenue de l'Europe
 *   38330 Montbonnot Saint Martin
 *   FRANCE
 *-----------------------------------------------------------------------------
 *   Module             :       caesar_graph.h
 *   Auteur             :       Hubert GARAVEL
 *   Version            :       1.33 [patched]
 *   Date               :       2017/09/04 15:32:41
 *****************************************************************************/

#ifndef CAESAR_GRAPH_INTERFACE_1

#define CAESAR_GRAPH_INTERFACE_1

#ifdef __cplusplus
extern "C" {
#endif

#ifdef CAESAR_UNDEFINED
}
#endif

/*****************************************************************************/

#include "caesar_standard.h"

#include "caesar_version.h"

/*---------------------------------------------------------------------------*/

extern CAESAR_TYPE_STRING CAESAR_GRAPH_COMPILER_1 CAESAR_ARG_0 ();

/*---------------------------------------------------------------------------*/

extern CAESAR_TYPE_VERSION CAESAR_GRAPH_VERSION_1 CAESAR_ARG_0 ();

/*---------------------------------------------------------------------------*/

extern void CAESAR_INIT_GRAPH_1 CAESAR_ARG_0 ();

/*---------------------------------------------------------------------------*/

#if !defined (CAESAR_GRAPH_IMPLEMENTATION) || (CAESAR_GRAPH_IMPLEMENTATION - 0 != 0)

/*
 * declaration du type CAESAR_TYPE_STATE_1 sauf dans le cas ou le present
 * fichier est inclus dans un programme C produit avec un compilateur
 * compatible Open/Caesar (par exemple, Caesar, Bcg_Open, etc.) mais obsolete
 * (anterieur a la version Open/Caesar 2.3 incluse), ce que l'on detecte en
 * testant que la variable CAESAR_GRAPH_IMPLEMENTATION est definie et egale a
 * la chaine vide
 */

typedef CAESAR_TYPE_ABSTRACT (CAESAR_STRUCT_STATE_1) CAESAR_TYPE_STATE_1;

#endif

/*---------------------------------------------------------------------------*/

/*** extern CAESAR_TYPE_NATURAL CAESAR_SIZE_STATE_1 CAESAR_ARG_0 (); ***/

#define CAESAR_SIZE_STATE_1() CAESAR_HINT_SIZE_STATE_1

extern CAESAR_TYPE_NATURAL CAESAR_HINT_SIZE_STATE_1;	/* not to be referenced! */

/*---------------------------------------------------------------------------*/

/*** extern CAESAR_TYPE_NATURAL CAESAR_HASH_SIZE_STATE_1 CAESAR_ARG_0 (); ***/

#define CAESAR_HASH_SIZE_STATE_1() CAESAR_HINT_HASH_SIZE_STATE_1

extern CAESAR_TYPE_NATURAL CAESAR_HINT_HASH_SIZE_STATE_1;	/* not to be referenced! */

/*---------------------------------------------------------------------------*/

/*** extern CAESAR_TYPE_NATURAL CAESAR_ALIGNMENT_STATE_1 CAESAR_ARG_0 (); ***/

#define CAESAR_ALIGNMENT_STATE_1() CAESAR_HINT_ALIGNMENT_STATE_1

extern CAESAR_TYPE_NATURAL CAESAR_HINT_ALIGNMENT_STATE_1;	/* not to be referenced! */

/*---------------------------------------------------------------------------*/

/*** extern void CAESAR_CREATE_STATE_1 CAESAR_ARG_1 (CAESAR_TYPE_STATE_1 *); ***/

#define CAESAR_CREATE_STATE_1(CAESAR_S) CAESAR_CREATE (*(CAESAR_S), CAESAR_SIZE_STATE_1(), CAESAR_TYPE_STATE_1)

/*---------------------------------------------------------------------------*/

/*** extern void CAESAR_DELETE_STATE_1 CAESAR_ARG_1 (CAESAR_TYPE_STATE_1 *); ***/

#define CAESAR_DELETE_STATE_1(CAESAR_S) { CAESAR_DELETE (*(CAESAR_S)); *(CAESAR_S) = NULL; }

/*---------------------------------------------------------------------------*/

/*** extern void CAESAR_COPY_STATE_1 CAESAR_ARG_2 (CAESAR_TYPE_STATE_1, CAESAR_TYPE_STATE_1); ***/

#if defined (CAESAR_GRAPH_IMPLEMENTATION) && defined (CAESAR_USE_STRUCT_ASSIGNMENT)

#define CAESAR_COPY_STATE_1(CAESAR_S1,CAESAR_S2) *(CAESAR_S1) = *(CAESAR_S2)

#else

#define CAESAR_COPY_STATE_1(CAESAR_S1,CAESAR_S2) (void) memcpy ((void *) (CAESAR_S1), (void *) (CAESAR_S2), (size_t) CAESAR_SIZE_STATE_1 ())

#endif

/*---------------------------------------------------------------------------*/

extern CAESAR_TYPE_BOOLEAN CAESAR_COMPARE_STATE_1 CAESAR_ARG_2 (CAESAR_TYPE_STATE_1, CAESAR_TYPE_STATE_1);

/*---------------------------------------------------------------------------*/

extern CAESAR_TYPE_NATURAL CAESAR_HASH_STATE_1 CAESAR_ARG_2 (CAESAR_TYPE_STATE_1, CAESAR_TYPE_NATURAL);

/*---------------------------------------------------------------------------*/

extern CAESAR_TYPE_FORMAT CAESAR_FORMAT_STATE_1 CAESAR_ARG_1 (CAESAR_PROMOTE_TO_INT (CAESAR_TYPE_FORMAT));

/*---------------------------------------------------------------------------*/

/* deprecated primitive, kept as a macro for backward compatibility */
#define CAESAR_MAX_FORMAT_STATE_1() (CAESAR_FORMAT_STATE_1 (CAESAR_MAXIMAL_FORMAT))

/*---------------------------------------------------------------------------*/

extern void CAESAR_PRINT_STATE_HEADER_1 CAESAR_ARG_1 (CAESAR_TYPE_FILE);

/*---------------------------------------------------------------------------*/

extern void CAESAR_PRINT_STATE_1 CAESAR_ARG_2 (CAESAR_TYPE_FILE, CAESAR_TYPE_STATE_1);

/*---------------------------------------------------------------------------*/

extern void CAESAR_DELTA_STATE_1 CAESAR_ARG_3 (CAESAR_TYPE_FILE, CAESAR_TYPE_STATE_1, CAESAR_TYPE_STATE_1);

/* ======================================================================== */

#if !defined (CAESAR_GRAPH_IMPLEMENTATION) || (CAESAR_GRAPH_IMPLEMENTATION - 0 != 0)

/*
 * declaration du type CAESAR_TYPE_LABEL_1 sauf dans le cas ou le present
 * fichier est inclus dans un programme C produit avec un compilateur
 * compatible Open/Caesar (par exemple, Caesar, Bcg_Open, etc.) mais obsolete
 * (anterieur a la version Open/Caesar 2.3 incluse), ce que l'on detecte en
 * testant que la variable CAESAR_GRAPH_IMPLEMENTATION est definie et egale a
 * la chaine vide
 */

typedef CAESAR_TYPE_ABSTRACT (CAESAR_STRUCT_LABEL_1) CAESAR_TYPE_LABEL_1;

#endif

/*---------------------------------------------------------------------------*/

/*** extern CAESAR_TYPE_NATURAL CAESAR_SIZE_LABEL_1 CAESAR_ARG_0 (); ***/

#define CAESAR_SIZE_LABEL_1() CAESAR_HINT_SIZE_LABEL_1

extern CAESAR_TYPE_NATURAL CAESAR_HINT_SIZE_LABEL_1;	/* not to be referenced! */

/*---------------------------------------------------------------------------*/

/*** extern CAESAR_TYPE_NATURAL CAESAR_HASH_SIZE_LABEL_1 CAESAR_ARG_0 (); ***/

#define CAESAR_HASH_SIZE_LABEL_1() CAESAR_HINT_HASH_SIZE_LABEL_1

extern CAESAR_TYPE_NATURAL CAESAR_HINT_HASH_SIZE_LABEL_1;	/* not to be referenced! */

/*---------------------------------------------------------------------------*/

/*** extern CAESAR_TYPE_NATURAL CAESAR_ALIGNMENT_LABEL_1 CAESAR_ARG_0 (); ***/

#define CAESAR_ALIGNMENT_LABEL_1() CAESAR_HINT_ALIGNMENT_LABEL_1

extern CAESAR_TYPE_NATURAL CAESAR_HINT_ALIGNMENT_LABEL_1;	/* not to be referenced! */

/*---------------------------------------------------------------------------*/

/*** extern void CAESAR_CREATE_LABEL_1 CAESAR_ARG_1 (CAESAR_TYPE_LABEL_1 *); ***/

#define CAESAR_CREATE_LABEL_1(CAESAR_L) CAESAR_CREATE (*(CAESAR_L), CAESAR_SIZE_LABEL_1(), CAESAR_TYPE_LABEL_1)

/*---------------------------------------------------------------------------*/

/*** extern void CAESAR_DELETE_LABEL_1 CAESAR_ARG_1 (CAESAR_TYPE_LABEL_1 *); ***/

#define CAESAR_DELETE_LABEL_1(CAESAR_L) { CAESAR_DELETE (*(CAESAR_L)); *(CAESAR_L) = NULL; }

/*---------------------------------------------------------------------------*/

extern CAESAR_TYPE_BOOLEAN CAESAR_VISIBLE_LABEL_1 CAESAR_ARG_1 (CAESAR_TYPE_LABEL_1);

/*---------------------------------------------------------------------------*/

extern CAESAR_TYPE_STRING CAESAR_GATE_LABEL_1 CAESAR_ARG_1 (CAESAR_TYPE_LABEL_1);

/*---------------------------------------------------------------------------*/

extern CAESAR_TYPE_NATURAL CAESAR_CARDINAL_LABEL_1 CAESAR_ARG_1 (CAESAR_TYPE_LABEL_1);

/*---------------------------------------------------------------------------*/

/*** extern void CAESAR_COPY_LABEL_1 CAESAR_ARG_2 (CAESAR_TYPE_LABEL_1, CAESAR_TYPE_LABEL_1); ***/

#if defined (CAESAR_GRAPH_IMPLEMENTATION) && defined (CAESAR_USE_STRUCT_ASSIGNMENT)

#define CAESAR_COPY_LABEL_1(CAESAR_L1,CAESAR_L2) *(CAESAR_L1) = *(CAESAR_L2)

#else

#define CAESAR_COPY_LABEL_1(CAESAR_L1,CAESAR_L2) (void) memcpy ((void *) (CAESAR_L1), (void *) (CAESAR_L2), (size_t) CAESAR_SIZE_LABEL_1 ())

#endif

/*---------------------------------------------------------------------------*/

extern CAESAR_TYPE_BOOLEAN CAESAR_COMPARE_LABEL_1 CAESAR_ARG_2 (CAESAR_TYPE_LABEL_1, CAESAR_TYPE_LABEL_1);

/*---------------------------------------------------------------------------*/

extern CAESAR_TYPE_NATURAL CAESAR_HASH_LABEL_1 CAESAR_ARG_2 (CAESAR_TYPE_LABEL_1, CAESAR_TYPE_NATURAL);

/*---------------------------------------------------------------------------*/

extern void CAESAR_PRINT_LABEL_1 CAESAR_ARG_2 (CAESAR_TYPE_FILE, CAESAR_TYPE_LABEL_1);

/*---------------------------------------------------------------------------*/

extern CAESAR_TYPE_STRING CAESAR_STRING_LABEL_1 CAESAR_ARG_1 (CAESAR_TYPE_LABEL_1);

/*---------------------------------------------------------------------------*/

extern CAESAR_TYPE_FORMAT CAESAR_FORMAT_LABEL_1 CAESAR_ARG_1 (CAESAR_PROMOTE_TO_INT (CAESAR_TYPE_FORMAT));

/*---------------------------------------------------------------------------*/

/* deprecated primitive, kept as a macro for backward compatibility */
#define CAESAR_MAX_FORMAT_LABEL_1() (CAESAR_FORMAT_LABEL_1 (CAESAR_MAXIMAL_FORMAT))

/*---------------------------------------------------------------------------*/

extern CAESAR_TYPE_STRING CAESAR_INFORMATION_LABEL_1 CAESAR_ARG_1 (CAESAR_TYPE_LABEL_1);

/* ======================================================================== */

extern void CAESAR_START_STATE_1 CAESAR_ARG_1 (CAESAR_TYPE_STATE_1);

/*---------------------------------------------------------------------------*/

extern void CAESAR_ITERATE_STATE_1 CAESAR_ARG_4 (CAESAR_TYPE_STATE_1, CAESAR_TYPE_LABEL_1, CAESAR_TYPE_STATE_1, void (*) (CAESAR_TYPE_STATE_1, CAESAR_TYPE_LABEL_1, CAESAR_TYPE_STATE_1));

/*****************************************************************************/

#ifdef CAESAR_UNDEFINED
{
#endif

#ifdef __cplusplus
}
#endif

#endif
