.\" @(#)bcg_alternatives.l - INRIA Rhone-Alpes - 2019/09/23
.TH CADP LOCAL "2019/09/23" "(C) INRIA" "CADP MANUAL PAGES"
.fp 4 CB
.lg 0
.SH NAME
bcg_alternatives \- extract alternatives from a complete test graph
 
.SH SYNOPSIS

.B bcg_alternatives
[\fB-monitor\fP]
[\fB-parse\fP|\fB-unparse\fP]
[[\fB-first\fP]\fB-select\fP]
[\fB-verbose\fP]
[\fB-version\fP]
\fB-input\fP|\fB-io\fP [\fB-gate\fP|\fB-partial\fP|\fB-total\fP] \fIfile\fP
\fIctg\fP[\fB.bcg\fP]
\fIalternatives\fP[\fB.bcg\fP]
.P

.SH DESCRIPTION
\fBbcg_alternatives\fP writes, for each uncontrollable state \fIs\fP of a CTG \fIctg\fP\fB.bcg\fP, the transitions going out from \fIs\fP to a file \fIalternatives\fP\fB.bcg\fP.
Both files are stored in the
.BR bcg (LOCAL)
format.
The transitions of \fIalternatives\fP\fB.bcg\fP are a subset of those of \fIctg\fP\fB.bcg\fP.
\fIalternatives\fP\fB.bcg\fP is likely not a connected graph.

See the
.BR testor (LOCAL)
manual page for a description of the match file format.
The default matching option is \fB-total\fP.

.SH B\&C\&G FORMAT
See the
.BR bcg (LOCAL)
manual page.

.SH OPTIONS
The following options are currently available:
.TP
.B -first\ \ \ \ \ \ \ \ \ 
In presence of option \fB-select\fP, select the first available alternative.
Not a default option.
.TP
\fB-input\fP|\fB-io\fP [\fB-gate\fP|\fB-partial\fP|\fB-total\fP] \fIfile\fP
Specify the inputs of the specification (outputs of the tester) according to the match file \fIfile\fP.
Mandatory option.
.TP
.B -last\ \ \ \ \ \ \ \ \ 
In presence of option \fB-select\fP, select the last available alternative.
If the states of the CTG (and thus the source states of the transitions of \fIalternatives\fP\fB.bcg\fP) are ordered according to a breadth-first traversal, \fB-last\fP will select an alternative with a maximal distance from the initial state.
Default in presence of option \fB-select\fP.
.TP
.B -monitor\ \ \ \ \ \ \ \ \ 
Open a window for monitoring in real-time the generation of each test case.
Not a default option.
.TP
.B -parse\ \ \ \ \ \ \ \ \ 
Enable label parsing in the generated test case.
See the
.BR bcg (LOCAL)
manual page for information about label parsing.
Default option.
.TP
.B -unparse\ \ \ \ 
Disable label parsing in the generated test case.
See the
.BR bcg (LOCAL)
manual page for information about label parsing.
Not a default option.
.TP
.BR -select\ \ \ 
Rather than extracting the list of alternatives, select one alternative from the list of alternatives.
Not a default option.
.TP
.BR -verbose\ \ \ 
Report in detail activities and progress to the user's screen.
Not a default option.
.TP
.BR -version\ \ \ 
Display the version number and stop.
Not a default option.

.SH OPERANDS
.PD 0
.TP 11
.IB ctg .bcg
complete test graph in the \fBbcg\fP format (input)
.TP
.IB alternatives .bcg
alternative transitions in the \fBbcg\fP format (output)
.TP
.I file
rules characterizing input labels (input)

.SH EXIT STATUS
Exit status is 0 if everything is alright, 1 otherwise.

.SH AUTHORS
Radu Mateescu and Wendelin Serwe.

.SH SEE ALSO
.P
.BR bcg (LOCAL),
.BR testor (LOCAL)

.P
Additional information is available from the CADP Web page located at
http://cadp.inria.fr
.P
Directives for installation are given in files \fB$CADP/INSTALLATION_*\fP.
.P
Recent changes and improvements to this software are reported
and commented in file \fB$CADP/HISTORY\fP.

.SH BUGS
Please report any bug to cadp@inria.fr

