.\" @(#)bcg_execute.l - INRIA Rhone-Alpes - 2021/03/08
.TH CADP LOCAL "2021/03/08" "(C) INRIA" "CADP MANUAL PAGES"
.fp 4 CB
.lg 0
.SH NAME
bcg_execute \- execute a BCG file as an SUT or TC
 
.SH SYNOPSIS

.B bcg_execute
\fB-input\fP|\fB-io\fP [\fB-gate\fP|\fB-partial\fP|\fB-total\fP] \fIfile\fP
[\fB-sut\fP|\fB-tc [\fB-tgv\fP]\fP]
[\fB-seed\fP \fIN\fP]
[\fB-timeout\fP \fIN\fP]
[\fB-version\fP]
\fIgraph\fP[\fB.bcg\fP]
.P

.SH DESCRIPTION
\fBbcg_execute\fP simulates the IOLTS \fIgraph\fP\fB.bcg\fP, reading inputs from standard input and writing outputs to the standard output, one transition label per line. 
The IOLTS is stored in the
.BR bcg (LOCAL)
format; inputs are defined by the file provided with the mandatory \fB-io\fP option.

.SH B\&C\&G FORMAT
See the
.BR bcg (LOCAL)
manual page.

.SH OPTIONS
The following options are currently available:
.TP
.B -angelic \ \ \ \ 
Use angelic completion for unspecified inputs.
This option is not meaningful in combination with option \fB-tc\fP.
Not a default option.
.TP
\fB-input\fP|\fB-io\fP [\fB-gate\fP|\fB-partial\fP|\fB-total\fP] \fIfile\fP
Specify the inputs of the specification (outputs of the tester) according to the match file \fIfile\fP.
Mandatory option.
.TP
.BI -seed \ N \ \ 
Use \fIN\fP as seed for the random number generator.
Not a default option.
.TP
.B -sut\ \ \ \ \ \ \ \ \ 
Interpret inputs/outputs as specified by the file provided with the mandatory \fB-io\fP option.
This is useful to execute a system under test.
Default option.
.TP
.B -tc\ \ \ \ \ \ \ \ \ 
Interpret inputs/outputs opposite to the specification in the file provided with the mandatory \fB-io\fP option.
This is useful to execute a test case.
Not a default option.
.TP
.B -tgv\ \ \ \ \ \ \ \ \ 
Make the hypothesis that the test case has the form of those generated by TGV, i.e.,
(1) each label carries a suffix indicating whether it is an inputs ("\fB; INPUT\fP") or an output ("\fB; OUTPUT\fP"), taking the view point of the test case ;
(2) the label of each transition leading to a verdict state carries a second suffix with verdict ("\fB (INCONCLUSIVE)\fP" or "\fB (PASS)\fP").
With this option, option \fB-io\fP is not mandatory (and ignored).
This option is only meaningful in combination with option \fB-tc\fP.
Not a default option.
.TP
.BI -timeout \ N \ \ 
Use \fIN\fP as the number of seconds for the quiescence detection timeout.
The default timeout value of 0 deactivates quiescence detection.
Unsupported feature for the win32 architecture.
.TP
.BR -version\ \ \ 
Display the version number and stop.
Not a default option.

.SH EXIT STATUS
Exit status is 0 if everything is alright, 1 otherwise.

.SH AUTHORS
Wendelin Serwe.

.SH SEE ALSO
.P
.BR bcg (LOCAL)

.P
Additional information is available from the CADP Web page located at
http://cadp.inria.fr
.P
Directives for installation are given in files \fB$CADP/INSTALLATION_*\fP.
.P
Recent changes and improvements to this software are reported
and commented in file \fB$CADP/HISTORY\fP.

.SH BUGS
Please report any bug to cadp@inria.fr

