.\" @(#)bcg_ioco.l - INRIA Rhone-Alpes - 2020/12/01
.TH CADP LOCAL "2020/12/01" "(C) INRIA" "CADP MANUAL PAGES"
.fp 4 CB
.lg 0
.SH NAME
bcg_ioco \- check ioco conformance of an SUT and a model M
 
.SH SYNOPSIS

.B bcg_ioco
\fB-input\fP|\fB-io\fP [\fB-gate\fP|\fB-partial\fP|\fB-total\fP] \fIfile\fP
[\fB-angelic\fP|\fB-demonic\fP]
[\fB-version\fP]
\fImodel\fP[\fB.bcg\fP]
\fIsut\fP[\fB.bcg\fP]
.P

.SH DESCRIPTION
\fBbcg_ioco\fP checks whether the IOTS \fIsut\fP\fB.bcg\fP is correct with respect to the ioco conformance relation to the IOLTS \fImodel\fP[\fB.bcg\fP].
The IOLTS \fImodel\fP[\fB.bcg\fP] and the IOTS \fIsut\fP[\fB.bcg\fP] are stored in the
.BR bcg (LOCAL)
format; inputs are defined by the file provided with the mandatory \fB-io\fP option.
In the case \fIsut\fP[\fB.bcg\fP] is not input-complete (i.e., it actually is an IOLTS, not an IOTS), \fBbcg_ioco\fP computes its angelic or demonic completion to an IOTS on the fly.

.SH B\&C\&G FORMAT
See the
.BR bcg (LOCAL)
manual page.

.SH OPTIONS
The following options are currently available:
.TP
\fB-input\fP|\fB-io\fP [\fB-gate\fP|\fB-partial\fP|\fB-total\fP] \fIfile\fP
Specify the inputs of the specification (outputs of the tester) according to the match file \fIfile\fP.
Mandatory option.
.TP
.B -angelic\ \ \ 
If necessary, transform the IOLTS \fIsut\fP[\fB.bcg\fP] into an IOTS using angelic completion, i.e., by adding for each unspecified input a corresponding self-loop transition.
Default option.
.TP
.B -demonic\ \ \ 
If necessary, transform the IOLTS \fIsut\fP[\fB.bcg\fP] into an IOTS using demonic completion, i.e., by adding for each unspecified input a transition to an error state.
Not a default option.
.TP
.BR -version\ \ \ 
Display the version number and stop.
Not a default option.

.SH EXIT STATUS
Exit status is 0 if everything is alright, 1 otherwise.

.SH AUTHORS
Wendelin Serwe.

.SH SEE ALSO
.P
.BR bcg (LOCAL)

.P
Additional information is available from the CADP Web page located at
http://cadp.inria.fr
.P
Directives for installation are given in files \fB$CADP/INSTALLATION_*\fP.
.P
Recent changes and improvements to this software are reported
and commented in file \fB$CADP/HISTORY\fP.

.SH BUGS
Please report any bug to cadp@inria.fr

