.\" @(#)bcg_union.l - INRIA Rhone-Alpes - 2020/07/10
.TH CADP LOCAL "2020/07/10" "(C) INRIA" "CADP MANUAL PAGES"
.fp 4 CB
.lg 0
.SH NAME
bcg_union \- compute the union of complete test graphs
 
.SH SYNOPSIS

.B bcg_union
[\fB-monitor\fP]
[\fB-parse\fP|\fB-unparse\fP]
[\fB-pass\fP]
[\fB-strip\fP]
[\fB-version\fP]
\fIctg1\fP[\fB.bcg\fP]
\fIctg2\fP[\fB.bcg\fP]
\fIresult\fP[\fB.bcg\fP]
.P

.SH DESCRIPTION
\fBbcg_union\fP computes the union of the two graphs \fIctg1\fP\fB.bcg\fP and \fIctg2\fP\fB.bcg\fP and writes the result in the file \fIresult\fP\fB.bcg\fP.
All three files are stored in the
.BR bcg (LOCAL)
format.

Intuitively, the result is the union of the two graphs, with a shared initial state and removal of all special transitions (verdicts and quiescence) occurring in a complete test graph.
Precisely, the set of states of the result is the initial state (numbered 0) plus the disjoint union of the sets of states of the graphs \fIctg1\fP\fB.bcg\fP and \fIctg2\fP\fB.bcg\fP excluding their initial state.
The set of transitions is the (disjoint) union of the sets of transitions of the graphs \fIctg1\fP\fB.bcg\fP and \fIctg2\fP\fB.bcg\fP, excluding all transitions corresponding to quiescence (i.e., labeled with "\fI:DELTA:\fP") or a verdict (i.e., labeled with "\fI:PASS:\fP" or "\fI:INCONCLUSIVE:\fP").
See the
.BR testor (LOCAL)
manual page for more information about complete test graphs, quiescence, and verdicts.

.SH B\&C\&G FORMAT
See the
.BR bcg (LOCAL)
manual page.

.SH OPTIONS
The following options are currently available:
.TP
.B -monitor\ \ \ \ \ \ \ \ \ 
Open a window for monitoring in real-time the generation of each test case.
Not a default option.
.TP
.B -parse\ \ \ \ \ \ \ \ \ 
Enable label parsing in the generated test case.
See the
.BR bcg (LOCAL)
manual page for information about label parsing.
Default option.
.TP
.BR -pass\ \ \ 
Exclude transitions leading to an inconclusive state from the union.
Not a default option.
.TP
.BR -strip\ \ \ 
Remove any inconclusive state and all transitions leading to an inconclusive state.
This option does not require the argument \fIctg2\fP\fB.bcg\fP.
Not a default option.
.TP
.B -unparse\ \ \ \ 
Disable label parsing in the generated test case.
See the
.BR bcg (LOCAL)
manual page for information about label parsing.
Not a default option.
.TP
.BR -version\ \ \ 
Display the version number and stop.
Not a default option.

.SH EXIT STATUS
Exit status is 0 if everything is alright, 1 otherwise.

.SH AUTHORS
Lina Marsso, Radu Mateescu, and Wendelin Serwe.

.SH SEE ALSO
.P
.BR bcg (LOCAL),
.BR testor (LOCAL)

.P
Additional information is available from the CADP Web page located at
http://cadp.inria.fr
.P
Directives for installation are given in files \fB$CADP/INSTALLATION_*\fP.
.P
Recent changes and improvements to this software are reported
and commented in file \fB$CADP/HISTORY\fP.

.SH BUGS
Please report any bug to cadp@inria.fr

